<?php

namespace FiloBlu\Newsletter\Block\LandingPage;

use Magento\Newsletter\Model\SubscriberFactory;

class FormRegister extends \Magento\Customer\Block\Form\Register {

    /**
     * Helper
     *
     * @var \FiloBlu\Newsletter\Helper\Data
     */
    public $_helper;
    protected $_coreRegistry;

    public function __construct(
    \Magento\Framework\View\Element\Template\Context $context, \Magento\Directory\Helper\Data $directoryHelper, \Magento\Framework\Json\EncoderInterface $jsonEncoder, \Magento\Framework\App\Cache\Type\Config $configCacheType, \Magento\Directory\Model\ResourceModel\Region\CollectionFactory $regionCollectionFactory, \Magento\Directory\Model\ResourceModel\Country\CollectionFactory $countryCollectionFactory, \Magento\Framework\Module\Manager $moduleManager, \Magento\Customer\Model\Session $customerSession, \Magento\Customer\Model\Url $customerUrl, \FiloBlu\Newsletter\Helper\Data $helper, \Magento\Framework\Registry $registry, array $data = []
    ) {
        $this->_helper = $helper;
        $this->_coreRegistry = $registry;
        parent::__construct(
                $context, $directoryHelper, $jsonEncoder, $configCacheType, $regionCollectionFactory, $countryCollectionFactory, $moduleManager, $customerSession, $customerUrl, $data
        );
    }

    /**
     * Retrieve form action url and set "secure" param to avoid confirm
     * message when we submit form from secure page to unsecure
     *
     * @return string
     */
    public function getFormActionUrl() {
        return $this->getUrl('newsletterajax/subscriber/newlandingregisteraction', ['_secure' => true]);
    }

    public function getLandingPage() {

        if (!$this->getLandingPageEntity()) {
            $this->setLandingPageEntity($this->_coreRegistry->registry('newsletter_landingpage_entity'));
        }

        return $this->getLandingPageEntity()->getData();
    }

    protected function _toHtml() {

        if (!$this->_helper->getConfig("general/enabled") || $this->getLandingPage()["form_type"] != 1) {
            return "";
        } else {
            return parent::_toHtml();
        }
    }

}
